/* tslint:disable */
/* eslint-disable */
/**
 * Halo Next API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Configuration } from "../configuration";
import type { AxiosPromise, AxiosInstance, AxiosRequestConfig } from "axios";
import globalAxios from "axios";
// Some imports not used depending on template conditions
// @ts-ignore
import {
  DUMMY_BASE_URL,
  assertParamExists,
  setApiKeyToObject,
  setBasicAuthToObject,
  setBearerAuthToObject,
  setOAuthToObject,
  setSearchParams,
  serializeDataIfNeeded,
  toPathString,
  createRequestFunction,
} from "../common";
// @ts-ignore
import {
  BASE_PATH,
  COLLECTION_FORMATS,
  RequestArgs,
  BaseAPI,
  RequiredError,
} from "../base";
// @ts-ignore
import { ConfigMap } from "../models";
// @ts-ignore
import { Plugin } from "../models";
// @ts-ignore
import { PluginList } from "../models";
// @ts-ignore
import { Setting } from "../models";
/**
 * ApiConsoleHaloRunV1alpha1PluginApi - axios parameter creator
 * @export
 */
export const ApiConsoleHaloRunV1alpha1PluginApiAxiosParamCreator = function (
  configuration?: Configuration
) {
  return {
    /**
     * Fetch configMap of plugin by configured configMapName.
     * @param {string} name
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    fetchPluginConfig: async (
      name: string,
      options: AxiosRequestConfig = {}
    ): Promise<RequestArgs> => {
      // verify required parameter 'name' is not null or undefined
      assertParamExists("fetchPluginConfig", "name", name);
      const localVarPath =
        `/apis/api.console.halo.run/v1alpha1/plugins/{name}/config`.replace(
          `{${"name"}}`,
          encodeURIComponent(String(name))
        );
      // use dummy base URL string because the URL constructor only accepts absolute URLs.
      const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
      let baseOptions;
      if (configuration) {
        baseOptions = configuration.baseOptions;
      }

      const localVarRequestOptions = {
        method: "GET",
        ...baseOptions,
        ...options,
      };
      const localVarHeaderParameter = {} as any;
      const localVarQueryParameter = {} as any;

      // authentication BasicAuth required
      // http basic authentication required
      setBasicAuthToObject(localVarRequestOptions, configuration);

      // authentication BearerAuth required
      // http bearer authentication required
      await setBearerAuthToObject(localVarHeaderParameter, configuration);

      setSearchParams(localVarUrlObj, localVarQueryParameter);
      let headersFromBaseOptions =
        baseOptions && baseOptions.headers ? baseOptions.headers : {};
      localVarRequestOptions.headers = {
        ...localVarHeaderParameter,
        ...headersFromBaseOptions,
        ...options.headers,
      };

      return {
        url: toPathString(localVarUrlObj),
        options: localVarRequestOptions,
      };
    },
    /**
     * Fetch setting of plugin.
     * @param {string} name
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    fetchPluginSetting: async (
      name: string,
      options: AxiosRequestConfig = {}
    ): Promise<RequestArgs> => {
      // verify required parameter 'name' is not null or undefined
      assertParamExists("fetchPluginSetting", "name", name);
      const localVarPath =
        `/apis/api.console.halo.run/v1alpha1/plugins/{name}/setting`.replace(
          `{${"name"}}`,
          encodeURIComponent(String(name))
        );
      // use dummy base URL string because the URL constructor only accepts absolute URLs.
      const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
      let baseOptions;
      if (configuration) {
        baseOptions = configuration.baseOptions;
      }

      const localVarRequestOptions = {
        method: "GET",
        ...baseOptions,
        ...options,
      };
      const localVarHeaderParameter = {} as any;
      const localVarQueryParameter = {} as any;

      // authentication BasicAuth required
      // http basic authentication required
      setBasicAuthToObject(localVarRequestOptions, configuration);

      // authentication BearerAuth required
      // http bearer authentication required
      await setBearerAuthToObject(localVarHeaderParameter, configuration);

      setSearchParams(localVarUrlObj, localVarQueryParameter);
      let headersFromBaseOptions =
        baseOptions && baseOptions.headers ? baseOptions.headers : {};
      localVarRequestOptions.headers = {
        ...localVarHeaderParameter,
        ...headersFromBaseOptions,
        ...options.headers,
      };

      return {
        url: toPathString(localVarUrlObj),
        options: localVarRequestOptions,
      };
    },
    /**
     * Install a plugin by uploading a Jar file.
     * @param {File} [file]
     * @param {string} [presetName] Plugin preset name. We will find the plugin from plugin presets
     * @param {string} [source] Install source. Default is file.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    installPlugin: async (
      file?: File,
      presetName?: string,
      source?: string,
      options: AxiosRequestConfig = {}
    ): Promise<RequestArgs> => {
      const localVarPath = `/apis/api.console.halo.run/v1alpha1/plugins/install`;
      // use dummy base URL string because the URL constructor only accepts absolute URLs.
      const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
      let baseOptions;
      if (configuration) {
        baseOptions = configuration.baseOptions;
      }

      const localVarRequestOptions = {
        method: "POST",
        ...baseOptions,
        ...options,
      };
      const localVarHeaderParameter = {} as any;
      const localVarQueryParameter = {} as any;
      const localVarFormParams = new ((configuration &&
        configuration.formDataCtor) ||
        FormData)();

      // authentication BasicAuth required
      // http basic authentication required
      setBasicAuthToObject(localVarRequestOptions, configuration);

      // authentication BearerAuth required
      // http bearer authentication required
      await setBearerAuthToObject(localVarHeaderParameter, configuration);

      if (file !== undefined) {
        localVarFormParams.append("file", file as any);
      }

      if (presetName !== undefined) {
        localVarFormParams.append("presetName", presetName as any);
      }

      if (source !== undefined) {
        localVarFormParams.append("source", source as any);
      }

      localVarHeaderParameter["Content-Type"] = "multipart/form-data";

      setSearchParams(localVarUrlObj, localVarQueryParameter);
      let headersFromBaseOptions =
        baseOptions && baseOptions.headers ? baseOptions.headers : {};
      localVarRequestOptions.headers = {
        ...localVarHeaderParameter,
        ...headersFromBaseOptions,
        ...options.headers,
      };
      localVarRequestOptions.data = localVarFormParams;

      return {
        url: toPathString(localVarUrlObj),
        options: localVarRequestOptions,
      };
    },
    /**
     * List all plugin presets in the system.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    listPluginPresets: async (
      options: AxiosRequestConfig = {}
    ): Promise<RequestArgs> => {
      const localVarPath = `/apis/api.console.halo.run/v1alpha1/plugin-presets`;
      // use dummy base URL string because the URL constructor only accepts absolute URLs.
      const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
      let baseOptions;
      if (configuration) {
        baseOptions = configuration.baseOptions;
      }

      const localVarRequestOptions = {
        method: "GET",
        ...baseOptions,
        ...options,
      };
      const localVarHeaderParameter = {} as any;
      const localVarQueryParameter = {} as any;

      // authentication BasicAuth required
      // http basic authentication required
      setBasicAuthToObject(localVarRequestOptions, configuration);

      // authentication BearerAuth required
      // http bearer authentication required
      await setBearerAuthToObject(localVarHeaderParameter, configuration);

      setSearchParams(localVarUrlObj, localVarQueryParameter);
      let headersFromBaseOptions =
        baseOptions && baseOptions.headers ? baseOptions.headers : {};
      localVarRequestOptions.headers = {
        ...localVarHeaderParameter,
        ...headersFromBaseOptions,
        ...options.headers,
      };

      return {
        url: toPathString(localVarUrlObj),
        options: localVarRequestOptions,
      };
    },
    /**
     * List plugins using query criteria and sort params
     * @param {Array<string>} [sort] Sort property and direction of the list result. Supported fields: creationTimestamp
     * @param {string} [keyword] Keyword of plugin name or description
     * @param {boolean} [enabled] Whether the plugin is enabled
     * @param {number} [size] Size of one page. Zero indicates no limit.
     * @param {Array<string>} [labelSelector] Label selector for filtering.
     * @param {Array<string>} [fieldSelector] Field selector for filtering.
     * @param {number} [page] The page number. Zero indicates no page.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    listPlugins: async (
      sort?: Array<string>,
      keyword?: string,
      enabled?: boolean,
      size?: number,
      labelSelector?: Array<string>,
      fieldSelector?: Array<string>,
      page?: number,
      options: AxiosRequestConfig = {}
    ): Promise<RequestArgs> => {
      const localVarPath = `/apis/api.console.halo.run/v1alpha1/plugins`;
      // use dummy base URL string because the URL constructor only accepts absolute URLs.
      const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
      let baseOptions;
      if (configuration) {
        baseOptions = configuration.baseOptions;
      }

      const localVarRequestOptions = {
        method: "GET",
        ...baseOptions,
        ...options,
      };
      const localVarHeaderParameter = {} as any;
      const localVarQueryParameter = {} as any;

      // authentication BasicAuth required
      // http basic authentication required
      setBasicAuthToObject(localVarRequestOptions, configuration);

      // authentication BearerAuth required
      // http bearer authentication required
      await setBearerAuthToObject(localVarHeaderParameter, configuration);

      if (sort) {
        localVarQueryParameter["sort"] = Array.from(sort);
      }

      if (keyword !== undefined) {
        localVarQueryParameter["keyword"] = keyword;
      }

      if (enabled !== undefined) {
        localVarQueryParameter["enabled"] = enabled;
      }

      if (size !== undefined) {
        localVarQueryParameter["size"] = size;
      }

      if (labelSelector) {
        localVarQueryParameter["labelSelector"] = labelSelector;
      }

      if (fieldSelector) {
        localVarQueryParameter["fieldSelector"] = fieldSelector;
      }

      if (page !== undefined) {
        localVarQueryParameter["page"] = page;
      }

      setSearchParams(localVarUrlObj, localVarQueryParameter);
      let headersFromBaseOptions =
        baseOptions && baseOptions.headers ? baseOptions.headers : {};
      localVarRequestOptions.headers = {
        ...localVarHeaderParameter,
        ...headersFromBaseOptions,
        ...options.headers,
      };

      return {
        url: toPathString(localVarUrlObj),
        options: localVarRequestOptions,
      };
    },
    /**
     * Reset the configMap of plugin setting.
     * @param {string} name
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    resetPluginConfig: async (
      name: string,
      options: AxiosRequestConfig = {}
    ): Promise<RequestArgs> => {
      // verify required parameter 'name' is not null or undefined
      assertParamExists("resetPluginConfig", "name", name);
      const localVarPath =
        `/apis/api.console.halo.run/v1alpha1/plugins/{name}/reset-config`.replace(
          `{${"name"}}`,
          encodeURIComponent(String(name))
        );
      // use dummy base URL string because the URL constructor only accepts absolute URLs.
      const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
      let baseOptions;
      if (configuration) {
        baseOptions = configuration.baseOptions;
      }

      const localVarRequestOptions = {
        method: "PUT",
        ...baseOptions,
        ...options,
      };
      const localVarHeaderParameter = {} as any;
      const localVarQueryParameter = {} as any;

      // authentication BasicAuth required
      // http basic authentication required
      setBasicAuthToObject(localVarRequestOptions, configuration);

      // authentication BearerAuth required
      // http bearer authentication required
      await setBearerAuthToObject(localVarHeaderParameter, configuration);

      setSearchParams(localVarUrlObj, localVarQueryParameter);
      let headersFromBaseOptions =
        baseOptions && baseOptions.headers ? baseOptions.headers : {};
      localVarRequestOptions.headers = {
        ...localVarHeaderParameter,
        ...headersFromBaseOptions,
        ...options.headers,
      };

      return {
        url: toPathString(localVarUrlObj),
        options: localVarRequestOptions,
      };
    },
    /**
     * Update the configMap of plugin setting.
     * @param {string} name
     * @param {ConfigMap} configMap
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    updatePluginConfig: async (
      name: string,
      configMap: ConfigMap,
      options: AxiosRequestConfig = {}
    ): Promise<RequestArgs> => {
      // verify required parameter 'name' is not null or undefined
      assertParamExists("updatePluginConfig", "name", name);
      // verify required parameter 'configMap' is not null or undefined
      assertParamExists("updatePluginConfig", "configMap", configMap);
      const localVarPath =
        `/apis/api.console.halo.run/v1alpha1/plugins/{name}/config`.replace(
          `{${"name"}}`,
          encodeURIComponent(String(name))
        );
      // use dummy base URL string because the URL constructor only accepts absolute URLs.
      const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
      let baseOptions;
      if (configuration) {
        baseOptions = configuration.baseOptions;
      }

      const localVarRequestOptions = {
        method: "PUT",
        ...baseOptions,
        ...options,
      };
      const localVarHeaderParameter = {} as any;
      const localVarQueryParameter = {} as any;

      // authentication BasicAuth required
      // http basic authentication required
      setBasicAuthToObject(localVarRequestOptions, configuration);

      // authentication BearerAuth required
      // http bearer authentication required
      await setBearerAuthToObject(localVarHeaderParameter, configuration);

      localVarHeaderParameter["Content-Type"] = "application/json";

      setSearchParams(localVarUrlObj, localVarQueryParameter);
      let headersFromBaseOptions =
        baseOptions && baseOptions.headers ? baseOptions.headers : {};
      localVarRequestOptions.headers = {
        ...localVarHeaderParameter,
        ...headersFromBaseOptions,
        ...options.headers,
      };
      localVarRequestOptions.data = serializeDataIfNeeded(
        configMap,
        localVarRequestOptions,
        configuration
      );

      return {
        url: toPathString(localVarUrlObj),
        options: localVarRequestOptions,
      };
    },
    /**
     * Upgrade a plugin by uploading a Jar file
     * @param {string} name
     * @param {File} [file]
     * @param {string} [presetName] Plugin preset name. We will find the plugin from plugin presets
     * @param {string} [source] Install source. Default is file.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    upgradePlugin: async (
      name: string,
      file?: File,
      presetName?: string,
      source?: string,
      options: AxiosRequestConfig = {}
    ): Promise<RequestArgs> => {
      // verify required parameter 'name' is not null or undefined
      assertParamExists("upgradePlugin", "name", name);
      const localVarPath =
        `/apis/api.console.halo.run/v1alpha1/plugins/{name}/upgrade`.replace(
          `{${"name"}}`,
          encodeURIComponent(String(name))
        );
      // use dummy base URL string because the URL constructor only accepts absolute URLs.
      const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
      let baseOptions;
      if (configuration) {
        baseOptions = configuration.baseOptions;
      }

      const localVarRequestOptions = {
        method: "POST",
        ...baseOptions,
        ...options,
      };
      const localVarHeaderParameter = {} as any;
      const localVarQueryParameter = {} as any;
      const localVarFormParams = new ((configuration &&
        configuration.formDataCtor) ||
        FormData)();

      // authentication BasicAuth required
      // http basic authentication required
      setBasicAuthToObject(localVarRequestOptions, configuration);

      // authentication BearerAuth required
      // http bearer authentication required
      await setBearerAuthToObject(localVarHeaderParameter, configuration);

      if (file !== undefined) {
        localVarFormParams.append("file", file as any);
      }

      if (presetName !== undefined) {
        localVarFormParams.append("presetName", presetName as any);
      }

      if (source !== undefined) {
        localVarFormParams.append("source", source as any);
      }

      localVarHeaderParameter["Content-Type"] = "multipart/form-data";

      setSearchParams(localVarUrlObj, localVarQueryParameter);
      let headersFromBaseOptions =
        baseOptions && baseOptions.headers ? baseOptions.headers : {};
      localVarRequestOptions.headers = {
        ...localVarHeaderParameter,
        ...headersFromBaseOptions,
        ...options.headers,
      };
      localVarRequestOptions.data = localVarFormParams;

      return {
        url: toPathString(localVarUrlObj),
        options: localVarRequestOptions,
      };
    },
  };
};

/**
 * ApiConsoleHaloRunV1alpha1PluginApi - functional programming interface
 * @export
 */
export const ApiConsoleHaloRunV1alpha1PluginApiFp = function (
  configuration?: Configuration
) {
  const localVarAxiosParamCreator =
    ApiConsoleHaloRunV1alpha1PluginApiAxiosParamCreator(configuration);
  return {
    /**
     * Fetch configMap of plugin by configured configMapName.
     * @param {string} name
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    async fetchPluginConfig(
      name: string,
      options?: AxiosRequestConfig
    ): Promise<
      (axios?: AxiosInstance, basePath?: string) => AxiosPromise<ConfigMap>
    > {
      const localVarAxiosArgs =
        await localVarAxiosParamCreator.fetchPluginConfig(name, options);
      return createRequestFunction(
        localVarAxiosArgs,
        globalAxios,
        BASE_PATH,
        configuration
      );
    },
    /**
     * Fetch setting of plugin.
     * @param {string} name
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    async fetchPluginSetting(
      name: string,
      options?: AxiosRequestConfig
    ): Promise<
      (axios?: AxiosInstance, basePath?: string) => AxiosPromise<Setting>
    > {
      const localVarAxiosArgs =
        await localVarAxiosParamCreator.fetchPluginSetting(name, options);
      return createRequestFunction(
        localVarAxiosArgs,
        globalAxios,
        BASE_PATH,
        configuration
      );
    },
    /**
     * Install a plugin by uploading a Jar file.
     * @param {File} [file]
     * @param {string} [presetName] Plugin preset name. We will find the plugin from plugin presets
     * @param {string} [source] Install source. Default is file.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    async installPlugin(
      file?: File,
      presetName?: string,
      source?: string,
      options?: AxiosRequestConfig
    ): Promise<
      (axios?: AxiosInstance, basePath?: string) => AxiosPromise<Plugin>
    > {
      const localVarAxiosArgs = await localVarAxiosParamCreator.installPlugin(
        file,
        presetName,
        source,
        options
      );
      return createRequestFunction(
        localVarAxiosArgs,
        globalAxios,
        BASE_PATH,
        configuration
      );
    },
    /**
     * List all plugin presets in the system.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    async listPluginPresets(
      options?: AxiosRequestConfig
    ): Promise<
      (axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<Plugin>>
    > {
      const localVarAxiosArgs =
        await localVarAxiosParamCreator.listPluginPresets(options);
      return createRequestFunction(
        localVarAxiosArgs,
        globalAxios,
        BASE_PATH,
        configuration
      );
    },
    /**
     * List plugins using query criteria and sort params
     * @param {Array<string>} [sort] Sort property and direction of the list result. Supported fields: creationTimestamp
     * @param {string} [keyword] Keyword of plugin name or description
     * @param {boolean} [enabled] Whether the plugin is enabled
     * @param {number} [size] Size of one page. Zero indicates no limit.
     * @param {Array<string>} [labelSelector] Label selector for filtering.
     * @param {Array<string>} [fieldSelector] Field selector for filtering.
     * @param {number} [page] The page number. Zero indicates no page.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    async listPlugins(
      sort?: Array<string>,
      keyword?: string,
      enabled?: boolean,
      size?: number,
      labelSelector?: Array<string>,
      fieldSelector?: Array<string>,
      page?: number,
      options?: AxiosRequestConfig
    ): Promise<
      (axios?: AxiosInstance, basePath?: string) => AxiosPromise<PluginList>
    > {
      const localVarAxiosArgs = await localVarAxiosParamCreator.listPlugins(
        sort,
        keyword,
        enabled,
        size,
        labelSelector,
        fieldSelector,
        page,
        options
      );
      return createRequestFunction(
        localVarAxiosArgs,
        globalAxios,
        BASE_PATH,
        configuration
      );
    },
    /**
     * Reset the configMap of plugin setting.
     * @param {string} name
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    async resetPluginConfig(
      name: string,
      options?: AxiosRequestConfig
    ): Promise<
      (axios?: AxiosInstance, basePath?: string) => AxiosPromise<ConfigMap>
    > {
      const localVarAxiosArgs =
        await localVarAxiosParamCreator.resetPluginConfig(name, options);
      return createRequestFunction(
        localVarAxiosArgs,
        globalAxios,
        BASE_PATH,
        configuration
      );
    },
    /**
     * Update the configMap of plugin setting.
     * @param {string} name
     * @param {ConfigMap} configMap
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    async updatePluginConfig(
      name: string,
      configMap: ConfigMap,
      options?: AxiosRequestConfig
    ): Promise<
      (axios?: AxiosInstance, basePath?: string) => AxiosPromise<ConfigMap>
    > {
      const localVarAxiosArgs =
        await localVarAxiosParamCreator.updatePluginConfig(
          name,
          configMap,
          options
        );
      return createRequestFunction(
        localVarAxiosArgs,
        globalAxios,
        BASE_PATH,
        configuration
      );
    },
    /**
     * Upgrade a plugin by uploading a Jar file
     * @param {string} name
     * @param {File} [file]
     * @param {string} [presetName] Plugin preset name. We will find the plugin from plugin presets
     * @param {string} [source] Install source. Default is file.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    async upgradePlugin(
      name: string,
      file?: File,
      presetName?: string,
      source?: string,
      options?: AxiosRequestConfig
    ): Promise<
      (axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>
    > {
      const localVarAxiosArgs = await localVarAxiosParamCreator.upgradePlugin(
        name,
        file,
        presetName,
        source,
        options
      );
      return createRequestFunction(
        localVarAxiosArgs,
        globalAxios,
        BASE_PATH,
        configuration
      );
    },
  };
};

/**
 * ApiConsoleHaloRunV1alpha1PluginApi - factory interface
 * @export
 */
export const ApiConsoleHaloRunV1alpha1PluginApiFactory = function (
  configuration?: Configuration,
  basePath?: string,
  axios?: AxiosInstance
) {
  const localVarFp = ApiConsoleHaloRunV1alpha1PluginApiFp(configuration);
  return {
    /**
     * Fetch configMap of plugin by configured configMapName.
     * @param {ApiConsoleHaloRunV1alpha1PluginApiFetchPluginConfigRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    fetchPluginConfig(
      requestParameters: ApiConsoleHaloRunV1alpha1PluginApiFetchPluginConfigRequest,
      options?: AxiosRequestConfig
    ): AxiosPromise<ConfigMap> {
      return localVarFp
        .fetchPluginConfig(requestParameters.name, options)
        .then((request) => request(axios, basePath));
    },
    /**
     * Fetch setting of plugin.
     * @param {ApiConsoleHaloRunV1alpha1PluginApiFetchPluginSettingRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    fetchPluginSetting(
      requestParameters: ApiConsoleHaloRunV1alpha1PluginApiFetchPluginSettingRequest,
      options?: AxiosRequestConfig
    ): AxiosPromise<Setting> {
      return localVarFp
        .fetchPluginSetting(requestParameters.name, options)
        .then((request) => request(axios, basePath));
    },
    /**
     * Install a plugin by uploading a Jar file.
     * @param {ApiConsoleHaloRunV1alpha1PluginApiInstallPluginRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    installPlugin(
      requestParameters: ApiConsoleHaloRunV1alpha1PluginApiInstallPluginRequest = {},
      options?: AxiosRequestConfig
    ): AxiosPromise<Plugin> {
      return localVarFp
        .installPlugin(
          requestParameters.file,
          requestParameters.presetName,
          requestParameters.source,
          options
        )
        .then((request) => request(axios, basePath));
    },
    /**
     * List all plugin presets in the system.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    listPluginPresets(
      options?: AxiosRequestConfig
    ): AxiosPromise<Array<Plugin>> {
      return localVarFp
        .listPluginPresets(options)
        .then((request) => request(axios, basePath));
    },
    /**
     * List plugins using query criteria and sort params
     * @param {ApiConsoleHaloRunV1alpha1PluginApiListPluginsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    listPlugins(
      requestParameters: ApiConsoleHaloRunV1alpha1PluginApiListPluginsRequest = {},
      options?: AxiosRequestConfig
    ): AxiosPromise<PluginList> {
      return localVarFp
        .listPlugins(
          requestParameters.sort,
          requestParameters.keyword,
          requestParameters.enabled,
          requestParameters.size,
          requestParameters.labelSelector,
          requestParameters.fieldSelector,
          requestParameters.page,
          options
        )
        .then((request) => request(axios, basePath));
    },
    /**
     * Reset the configMap of plugin setting.
     * @param {ApiConsoleHaloRunV1alpha1PluginApiResetPluginConfigRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    resetPluginConfig(
      requestParameters: ApiConsoleHaloRunV1alpha1PluginApiResetPluginConfigRequest,
      options?: AxiosRequestConfig
    ): AxiosPromise<ConfigMap> {
      return localVarFp
        .resetPluginConfig(requestParameters.name, options)
        .then((request) => request(axios, basePath));
    },
    /**
     * Update the configMap of plugin setting.
     * @param {ApiConsoleHaloRunV1alpha1PluginApiUpdatePluginConfigRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    updatePluginConfig(
      requestParameters: ApiConsoleHaloRunV1alpha1PluginApiUpdatePluginConfigRequest,
      options?: AxiosRequestConfig
    ): AxiosPromise<ConfigMap> {
      return localVarFp
        .updatePluginConfig(
          requestParameters.name,
          requestParameters.configMap,
          options
        )
        .then((request) => request(axios, basePath));
    },
    /**
     * Upgrade a plugin by uploading a Jar file
     * @param {ApiConsoleHaloRunV1alpha1PluginApiUpgradePluginRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    upgradePlugin(
      requestParameters: ApiConsoleHaloRunV1alpha1PluginApiUpgradePluginRequest,
      options?: AxiosRequestConfig
    ): AxiosPromise<void> {
      return localVarFp
        .upgradePlugin(
          requestParameters.name,
          requestParameters.file,
          requestParameters.presetName,
          requestParameters.source,
          options
        )
        .then((request) => request(axios, basePath));
    },
  };
};

/**
 * Request parameters for fetchPluginConfig operation in ApiConsoleHaloRunV1alpha1PluginApi.
 * @export
 * @interface ApiConsoleHaloRunV1alpha1PluginApiFetchPluginConfigRequest
 */
export interface ApiConsoleHaloRunV1alpha1PluginApiFetchPluginConfigRequest {
  /**
   *
   * @type {string}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiFetchPluginConfig
   */
  readonly name: string;
}

/**
 * Request parameters for fetchPluginSetting operation in ApiConsoleHaloRunV1alpha1PluginApi.
 * @export
 * @interface ApiConsoleHaloRunV1alpha1PluginApiFetchPluginSettingRequest
 */
export interface ApiConsoleHaloRunV1alpha1PluginApiFetchPluginSettingRequest {
  /**
   *
   * @type {string}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiFetchPluginSetting
   */
  readonly name: string;
}

/**
 * Request parameters for installPlugin operation in ApiConsoleHaloRunV1alpha1PluginApi.
 * @export
 * @interface ApiConsoleHaloRunV1alpha1PluginApiInstallPluginRequest
 */
export interface ApiConsoleHaloRunV1alpha1PluginApiInstallPluginRequest {
  /**
   *
   * @type {File}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiInstallPlugin
   */
  readonly file?: File;

  /**
   * Plugin preset name. We will find the plugin from plugin presets
   * @type {string}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiInstallPlugin
   */
  readonly presetName?: string;

  /**
   * Install source. Default is file.
   * @type {string}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiInstallPlugin
   */
  readonly source?: string;
}

/**
 * Request parameters for listPlugins operation in ApiConsoleHaloRunV1alpha1PluginApi.
 * @export
 * @interface ApiConsoleHaloRunV1alpha1PluginApiListPluginsRequest
 */
export interface ApiConsoleHaloRunV1alpha1PluginApiListPluginsRequest {
  /**
   * Sort property and direction of the list result. Supported fields: creationTimestamp
   * @type {Array<string>}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiListPlugins
   */
  readonly sort?: Array<string>;

  /**
   * Keyword of plugin name or description
   * @type {string}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiListPlugins
   */
  readonly keyword?: string;

  /**
   * Whether the plugin is enabled
   * @type {boolean}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiListPlugins
   */
  readonly enabled?: boolean;

  /**
   * Size of one page. Zero indicates no limit.
   * @type {number}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiListPlugins
   */
  readonly size?: number;

  /**
   * Label selector for filtering.
   * @type {Array<string>}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiListPlugins
   */
  readonly labelSelector?: Array<string>;

  /**
   * Field selector for filtering.
   * @type {Array<string>}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiListPlugins
   */
  readonly fieldSelector?: Array<string>;

  /**
   * The page number. Zero indicates no page.
   * @type {number}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiListPlugins
   */
  readonly page?: number;
}

/**
 * Request parameters for resetPluginConfig operation in ApiConsoleHaloRunV1alpha1PluginApi.
 * @export
 * @interface ApiConsoleHaloRunV1alpha1PluginApiResetPluginConfigRequest
 */
export interface ApiConsoleHaloRunV1alpha1PluginApiResetPluginConfigRequest {
  /**
   *
   * @type {string}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiResetPluginConfig
   */
  readonly name: string;
}

/**
 * Request parameters for updatePluginConfig operation in ApiConsoleHaloRunV1alpha1PluginApi.
 * @export
 * @interface ApiConsoleHaloRunV1alpha1PluginApiUpdatePluginConfigRequest
 */
export interface ApiConsoleHaloRunV1alpha1PluginApiUpdatePluginConfigRequest {
  /**
   *
   * @type {string}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiUpdatePluginConfig
   */
  readonly name: string;

  /**
   *
   * @type {ConfigMap}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiUpdatePluginConfig
   */
  readonly configMap: ConfigMap;
}

/**
 * Request parameters for upgradePlugin operation in ApiConsoleHaloRunV1alpha1PluginApi.
 * @export
 * @interface ApiConsoleHaloRunV1alpha1PluginApiUpgradePluginRequest
 */
export interface ApiConsoleHaloRunV1alpha1PluginApiUpgradePluginRequest {
  /**
   *
   * @type {string}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiUpgradePlugin
   */
  readonly name: string;

  /**
   *
   * @type {File}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiUpgradePlugin
   */
  readonly file?: File;

  /**
   * Plugin preset name. We will find the plugin from plugin presets
   * @type {string}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiUpgradePlugin
   */
  readonly presetName?: string;

  /**
   * Install source. Default is file.
   * @type {string}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApiUpgradePlugin
   */
  readonly source?: string;
}

/**
 * ApiConsoleHaloRunV1alpha1PluginApi - object-oriented interface
 * @export
 * @class ApiConsoleHaloRunV1alpha1PluginApi
 * @extends {BaseAPI}
 */
export class ApiConsoleHaloRunV1alpha1PluginApi extends BaseAPI {
  /**
   * Fetch configMap of plugin by configured configMapName.
   * @param {ApiConsoleHaloRunV1alpha1PluginApiFetchPluginConfigRequest} requestParameters Request parameters.
   * @param {*} [options] Override http request option.
   * @throws {RequiredError}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApi
   */
  public fetchPluginConfig(
    requestParameters: ApiConsoleHaloRunV1alpha1PluginApiFetchPluginConfigRequest,
    options?: AxiosRequestConfig
  ) {
    return ApiConsoleHaloRunV1alpha1PluginApiFp(this.configuration)
      .fetchPluginConfig(requestParameters.name, options)
      .then((request) => request(this.axios, this.basePath));
  }

  /**
   * Fetch setting of plugin.
   * @param {ApiConsoleHaloRunV1alpha1PluginApiFetchPluginSettingRequest} requestParameters Request parameters.
   * @param {*} [options] Override http request option.
   * @throws {RequiredError}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApi
   */
  public fetchPluginSetting(
    requestParameters: ApiConsoleHaloRunV1alpha1PluginApiFetchPluginSettingRequest,
    options?: AxiosRequestConfig
  ) {
    return ApiConsoleHaloRunV1alpha1PluginApiFp(this.configuration)
      .fetchPluginSetting(requestParameters.name, options)
      .then((request) => request(this.axios, this.basePath));
  }

  /**
   * Install a plugin by uploading a Jar file.
   * @param {ApiConsoleHaloRunV1alpha1PluginApiInstallPluginRequest} requestParameters Request parameters.
   * @param {*} [options] Override http request option.
   * @throws {RequiredError}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApi
   */
  public installPlugin(
    requestParameters: ApiConsoleHaloRunV1alpha1PluginApiInstallPluginRequest = {},
    options?: AxiosRequestConfig
  ) {
    return ApiConsoleHaloRunV1alpha1PluginApiFp(this.configuration)
      .installPlugin(
        requestParameters.file,
        requestParameters.presetName,
        requestParameters.source,
        options
      )
      .then((request) => request(this.axios, this.basePath));
  }

  /**
   * List all plugin presets in the system.
   * @param {*} [options] Override http request option.
   * @throws {RequiredError}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApi
   */
  public listPluginPresets(options?: AxiosRequestConfig) {
    return ApiConsoleHaloRunV1alpha1PluginApiFp(this.configuration)
      .listPluginPresets(options)
      .then((request) => request(this.axios, this.basePath));
  }

  /**
   * List plugins using query criteria and sort params
   * @param {ApiConsoleHaloRunV1alpha1PluginApiListPluginsRequest} requestParameters Request parameters.
   * @param {*} [options] Override http request option.
   * @throws {RequiredError}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApi
   */
  public listPlugins(
    requestParameters: ApiConsoleHaloRunV1alpha1PluginApiListPluginsRequest = {},
    options?: AxiosRequestConfig
  ) {
    return ApiConsoleHaloRunV1alpha1PluginApiFp(this.configuration)
      .listPlugins(
        requestParameters.sort,
        requestParameters.keyword,
        requestParameters.enabled,
        requestParameters.size,
        requestParameters.labelSelector,
        requestParameters.fieldSelector,
        requestParameters.page,
        options
      )
      .then((request) => request(this.axios, this.basePath));
  }

  /**
   * Reset the configMap of plugin setting.
   * @param {ApiConsoleHaloRunV1alpha1PluginApiResetPluginConfigRequest} requestParameters Request parameters.
   * @param {*} [options] Override http request option.
   * @throws {RequiredError}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApi
   */
  public resetPluginConfig(
    requestParameters: ApiConsoleHaloRunV1alpha1PluginApiResetPluginConfigRequest,
    options?: AxiosRequestConfig
  ) {
    return ApiConsoleHaloRunV1alpha1PluginApiFp(this.configuration)
      .resetPluginConfig(requestParameters.name, options)
      .then((request) => request(this.axios, this.basePath));
  }

  /**
   * Update the configMap of plugin setting.
   * @param {ApiConsoleHaloRunV1alpha1PluginApiUpdatePluginConfigRequest} requestParameters Request parameters.
   * @param {*} [options] Override http request option.
   * @throws {RequiredError}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApi
   */
  public updatePluginConfig(
    requestParameters: ApiConsoleHaloRunV1alpha1PluginApiUpdatePluginConfigRequest,
    options?: AxiosRequestConfig
  ) {
    return ApiConsoleHaloRunV1alpha1PluginApiFp(this.configuration)
      .updatePluginConfig(
        requestParameters.name,
        requestParameters.configMap,
        options
      )
      .then((request) => request(this.axios, this.basePath));
  }

  /**
   * Upgrade a plugin by uploading a Jar file
   * @param {ApiConsoleHaloRunV1alpha1PluginApiUpgradePluginRequest} requestParameters Request parameters.
   * @param {*} [options] Override http request option.
   * @throws {RequiredError}
   * @memberof ApiConsoleHaloRunV1alpha1PluginApi
   */
  public upgradePlugin(
    requestParameters: ApiConsoleHaloRunV1alpha1PluginApiUpgradePluginRequest,
    options?: AxiosRequestConfig
  ) {
    return ApiConsoleHaloRunV1alpha1PluginApiFp(this.configuration)
      .upgradePlugin(
        requestParameters.name,
        requestParameters.file,
        requestParameters.presetName,
        requestParameters.source,
        options
      )
      .then((request) => request(this.axios, this.basePath));
  }
}
